#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

void bye()
{
	printf("That was all, folks\n");
}

void bye2()
{
	printf("Really all\n");
}

void bye3(int status, void *arg)
{
	printf("Status %d, message %s\n", status, (char *)arg);
}

int main()
{
	long a;
	int i;

	a = sysconf(_SC_ATEXIT_MAX);
	printf("ATEXIT_MAX = %ld\n", a);
	fflush(stdout);
	/* 
		nel caso venga eseguito _exit alla fine, la printf di sopra potrebbe non essere eseguita: 
		infatti, tra le cose che fa la exit c'e' anche quella di eseguire tutte le operazioni
		di input/output rimaste nel buffer. La fflush garantisce che comunque la scrittura venga effettuata
		in ogni caso
	*/

	i = atexit(bye2);
	if (i != 0) {
		 fprintf(stderr, "cannot set exit function\n");
		 exit(EXIT_FAILURE);
	}

#if (_BSD_SOURCE || _SVID_SOURCE)
	i = on_exit(bye3, "ciao");
	if (i != 0) {
		 fprintf(stderr, "cannot set exit function\n");
		 exit(EXIT_FAILURE);
	}
#endif

	i = atexit(bye);
	if (i != 0) {
		 fprintf(stderr, "cannot set exit function\n");
		 exit(EXIT_FAILURE);
	}

#ifndef ESEGUI_IN_USCITA
	_exit(EXIT_SUCCESS);
#else
	exit(10);
#endif
}
